/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.ext.auth.oauth2.providers;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * Simplified factory to create an  for LinkedIn.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.auth.oauth2.providers.LinkedInAuth original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.ext.auth.oauth2.providers.LinkedInAuth.class)
public class LinkedInAuth {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    LinkedInAuth that = (LinkedInAuth) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<LinkedInAuth> __TYPE_ARG = new TypeArg<>(    obj -> new LinkedInAuth((io.vertx.ext.auth.oauth2.providers.LinkedInAuth) obj),
    LinkedInAuth::getDelegate
  );

  private final io.vertx.ext.auth.oauth2.providers.LinkedInAuth delegate;
  
  public LinkedInAuth(io.vertx.ext.auth.oauth2.providers.LinkedInAuth delegate) {
    this.delegate = delegate;
  }

  public LinkedInAuth(Object delegate) {
    this.delegate = (io.vertx.ext.auth.oauth2.providers.LinkedInAuth)delegate;
  }

  public io.vertx.ext.auth.oauth2.providers.LinkedInAuth getDelegate() {
    return delegate;
  }

  /**
   * Create a OAuth2Auth provider for LinkedIn
   * @param vertx 
   * @param clientId the client id given to you by LinkedIn
   * @param clientSecret the client secret given to you by LinkedIn
   * @return 
   */
  public static io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth create(io.vertx.rxjava.core.Vertx vertx, java.lang.String clientId, java.lang.String clientSecret) { 
    io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth ret = io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth.newInstance((io.vertx.ext.auth.oauth2.OAuth2Auth)io.vertx.ext.auth.oauth2.providers.LinkedInAuth.create(vertx.getDelegate(), clientId, clientSecret));
    return ret;
  }

  /**
   * Create a OAuth2Auth provider for LinkedIn
   * @param vertx 
   * @param clientId the client id given to you by LinkedIn
   * @param clientSecret the client secret given to you by LinkedIn
   * @param httpClientOptions custom http client options
   * @return 
   */
  public static io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth create(io.vertx.rxjava.core.Vertx vertx, java.lang.String clientId, java.lang.String clientSecret, io.vertx.core.http.HttpClientOptions httpClientOptions) { 
    io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth ret = io.vertx.rxjava.ext.auth.oauth2.OAuth2Auth.newInstance((io.vertx.ext.auth.oauth2.OAuth2Auth)io.vertx.ext.auth.oauth2.providers.LinkedInAuth.create(vertx.getDelegate(), clientId, clientSecret, httpClientOptions));
    return ret;
  }

  public static LinkedInAuth newInstance(io.vertx.ext.auth.oauth2.providers.LinkedInAuth arg) {
    return arg != null ? new LinkedInAuth(arg) : null;
  }

}
