/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.ext.web.validation;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * Result of a {@link io.vertx.rxjava.ext.web.validation.RequestPredicate}
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.web.validation.RequestPredicateResult original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.ext.web.validation.RequestPredicateResult.class)
public class RequestPredicateResult {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    RequestPredicateResult that = (RequestPredicateResult) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<RequestPredicateResult> __TYPE_ARG = new TypeArg<>(    obj -> new RequestPredicateResult((io.vertx.ext.web.validation.RequestPredicateResult) obj),
    RequestPredicateResult::getDelegate
  );

  private final io.vertx.ext.web.validation.RequestPredicateResult delegate;
  
  public RequestPredicateResult(io.vertx.ext.web.validation.RequestPredicateResult delegate) {
    this.delegate = delegate;
  }

  public RequestPredicateResult(Object delegate) {
    this.delegate = (io.vertx.ext.web.validation.RequestPredicateResult)delegate;
  }

  public io.vertx.ext.web.validation.RequestPredicateResult getDelegate() {
    return delegate;
  }

  /**
   * Predicate succeeded
   * @return 
   */
  public boolean succeeded() { 
    boolean ret = delegate.succeeded();
    return ret;
  }

  /**
   * Get error of failure
   * @return 
   */
  public java.lang.String getErrorMessage() { 
    java.lang.String ret = delegate.getErrorMessage();
    return ret;
  }

  public static io.vertx.rxjava.ext.web.validation.RequestPredicateResult success() { 
    io.vertx.rxjava.ext.web.validation.RequestPredicateResult ret = io.vertx.rxjava.ext.web.validation.RequestPredicateResult.newInstance((io.vertx.ext.web.validation.RequestPredicateResult)io.vertx.ext.web.validation.RequestPredicateResult.success());
    return ret;
  }

  public static io.vertx.rxjava.ext.web.validation.RequestPredicateResult failed(java.lang.String message) { 
    io.vertx.rxjava.ext.web.validation.RequestPredicateResult ret = io.vertx.rxjava.ext.web.validation.RequestPredicateResult.newInstance((io.vertx.ext.web.validation.RequestPredicateResult)io.vertx.ext.web.validation.RequestPredicateResult.failed(message));
    return ret;
  }

  public static RequestPredicateResult newInstance(io.vertx.ext.web.validation.RequestPredicateResult arg) {
    return arg != null ? new RequestPredicateResult(arg) : null;
  }

}
