/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.mqtt.messages;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * Represents an MQTT UNSUBSCRIBE message
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.mqtt.messages.MqttUnsubscribeMessage original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.mqtt.messages.MqttUnsubscribeMessage.class)
public class MqttUnsubscribeMessage implements io.vertx.rxjava.mqtt.messages.MqttMessage {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    MqttUnsubscribeMessage that = (MqttUnsubscribeMessage) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<MqttUnsubscribeMessage> __TYPE_ARG = new TypeArg<>(    obj -> new MqttUnsubscribeMessage((io.vertx.mqtt.messages.MqttUnsubscribeMessage) obj),
    MqttUnsubscribeMessage::getDelegate
  );

  private final io.vertx.mqtt.messages.MqttUnsubscribeMessage delegate;
  
  public MqttUnsubscribeMessage(io.vertx.mqtt.messages.MqttUnsubscribeMessage delegate) {
    this.delegate = delegate;
  }

  public MqttUnsubscribeMessage(Object delegate) {
    this.delegate = (io.vertx.mqtt.messages.MqttUnsubscribeMessage)delegate;
  }

  public io.vertx.mqtt.messages.MqttUnsubscribeMessage getDelegate() {
    return delegate;
  }


  /**
   * @return Message identifier
   */
  public int messageId() { 
    if (cached_0 != null) {
      return cached_0;
    }
    int ret = delegate.messageId();
    cached_0 = ret;
    return ret;
  }

  /**
   * @return List of topics to unsubscribe
   */
  public java.util.List<java.lang.String> topics() { 
    if (cached_1 != null) {
      return cached_1;
    }
    java.util.List<java.lang.String> ret = delegate.topics();
    cached_1 = ret;
    return ret;
  }

  private java.lang.Integer cached_0;
  private java.util.List<java.lang.String> cached_1;
  public static MqttUnsubscribeMessage newInstance(io.vertx.mqtt.messages.MqttUnsubscribeMessage arg) {
    return arg != null ? new MqttUnsubscribeMessage(arg) : null;
  }

}
